 /*
 * @(#)cbnMap.java        1.0 2004/07/30
 *
 * Copyright (c) 2004 CAVS, All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and
 * without fee is hereby granted.
 *
 */
package bullybus;
import java.io.*;
import java.sql.*;
import java.util.*;
/** 
 * A class to act as a container for useful information
 * about the status on the gauges of a vehicle.
 *
 * @author Ron Lewis
 * @version 1.0 07/03/2004
 */
public class CbnGaugeData implements Serializable{
    /**
     * The id of the bus this data comes from.
     */
    private String busId;
    /**
     * The current speed.
     */
    private int speed;
    /**
     * The current rpms.
     */
    private int rpm;
    /**
     * The current tps reading.
     */
    private int tps;
    /**
     * The current engine load
     */
    private int engLoad;
    /**
     * The current intake pressure.
     */
    private int intakePres;
    /**
     * The current temperature.
     */
     private int coolantTemp;
    /**
     * Class constructor: Constructs a new cbnGaugeData given initial data.
     */
    public CbnGaugeData(String busId, int speed, int rpm, int tps, 
			int engLoad, int intakePres, int coolantTemp){
	this.busId = busId;
	this.speed = speed;
	this.rpm = rpm;
	this.tps = tps;
	this.engLoad = engLoad;
	this.intakePres = intakePres;
	this.coolantTemp = coolantTemp;
    }
    /**
     * Constructs new cbnGaugeData
     */
    public CbnGaugeData()
    {
	this.busId = null;
	this.speed = 0;
	this.rpm = 0;
	this.tps = 0;
	this.engLoad = 0;
	this.intakePres = 0;
	this.coolantTemp = 0;
    }
    /**
     * Return the contents of the busId variable.
     */
    public String getBusId(){ 
	return busId; 
    }
    /**
     * Return the contents of the speed variable.
     */
    public int getSpeed(){ 
	return speed; 
    }
    /**
     * Return the contents of the rpm variable.
     */
    public int getRpm(){ 
	return rpm; 
    }
    /**
     * Return the contents of the tps variable.
     */
    public int getTps(){ 
	return tps; 
    }
    /**
     * Return the contents of the engLoad variable.
     */
    public int getEngLoad(){ 
	return engLoad; 
    }
    /**
     * Return the contents of the intakePres variable.
     */
    public int getIntakePres(){ 
	return intakePres; 
    }
    /**
     * Return the contents of the coolantTemp variable.
     */
    public int getCoolantTemp(){ 
	return coolantTemp; 
    }
    /**
     * Set all data variables.
     */
    public void setData(String busId, int speed, int rpm, 
			int tps, int engLoad, int intakePres, 
			int coolantTemp){
	this.busId = busId;
	this.speed = speed;
	this.rpm = rpm;
	this.tps = tps;
	this.engLoad = engLoad;
	this.intakePres = intakePres;
	this.coolantTemp = coolantTemp;
    }
    /**
     * Set the busId.
     */
    public void setBusId(String busId){ 
	this.busId = busId; 
    }
    /**
     * Set the current speed.
     */
    public void setSpeed(int speed){ 
	this.speed = speed; 
    }
    /**
     * Set the current rpm.
     */
    public void setRpm(int r){ 
	this.rpm = rpm; 
    }
    /**
     * Set the current tps value.
     */
    public void setTps(int tps){ 
	this.tps = tps; 
    }
    /**
     * Set the current engine load.
     */
    public void setEngLoad(int engLoad){ 
	this.engLoad = engLoad; 
    }
    /**
     * Set the current intake pressure.
     */
    public void setIntakePres(int intakePres){ 
	this.intakePres = intakePres; 
    }
    /**
     * Set the current coolant temperature.
     */
    public void setCoolantTemp(int coolantTemp){ 
	this.coolantTemp = coolantTemp; 
    }
}
