 /*
 * @(#)cbnGaugeDataSet.java        1.0 2004/07/30
 *
 * Copyright (c) 2004 CAVS, All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and
 * without fee is hereby granted.
 *
 */
package bullybus;
import java.io.*;
import java.sql.*;
import java.util.*;
/** 
 * A class to act as a container for useful information
 * about the status on the gauges of a vehicle.
 *
 * @author Ron Lewis
 * @version 2.0 01/25/2005
 */
public class CbnGaugeDataSet implements Serializable{
    
    static final long serialVersionUID = 7938911832794382414L;
    /**
     * The Vector of CbnGaugeData.
     */
    private Vector data = new Vector();
    /**
     * Sole constructor: creates a blank set.
     */
    public CbnGaugeDataSet(){
    }  
    /**
     * Append a data element to the Vector.
     * @param D the data element to be appended.
     */
    public boolean add(CbnGaugeData D)
    {
	return data.add(D);
    }
    /**
     * Return the Size of the Vector
     * @return the size of the vector.
     */
    public int getSize()
    {
	return data.size();
    }
    /**
     * Return the CbnGaugeData element at the specified index.
     * @return the CbnGaugeData element at the specified index.
     * @param i the specified index.
     */
    public CbnGaugeData getData(int i)
    {
       	return (CbnGaugeData)data.elementAt(i);
    }

}
