/*
 * @(#)CbnBuses.java        1.0 2004/07/30
 *
 * Copyright (c) 2004 CAVS, All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and
 * without fee is hereby granted.
 *
 */
package bullybus;
import java.io.*;
import java.sql.*;
import java.util.*;
/** 
 * A class to act as a container for route data. 
 * 
 *
 * @author Ron Lewis
 * @version 1.0 07/03/2004
 */
public class CbnRouteData implements Serializable{

    /**
     * The latitude of the coordinate.
     */
    public double gpsN;
    /**
     * The longitude of the coordinate
     */
    public double gpsW;
    /**
     * The distance from this coordinate to the next stop.
     */
    public double distToNextStop;
    /**
     * The name of the next stop.
     */
    public String nextStop;
    /**
     * Stop identification, True if this coordinate is a stop. False otherwise.
     */
    public boolean isAStop;
    /**
     * Sole Constructor creates a data element with the initial data specified.
     * @param gpsN The latitude of the coordinate.
     * @param gpsW The longitude of the coordinate.
     * @param d The distance from this coordinate to the next stop.
     * @param nextStop The name of the next stop.
     * @param i Stop identification, if this coordinate is a stop it is a 1 else a 0.
     */
    public CbnRouteData(double gpsN, double gpsW, double d, String nextStop, int i ){
   
	this.gpsN = gpsN;
        this.gpsW = gpsW;
        this.distToNextStop = d;
        this.nextStop = nextStop;
        if(i != 1)
            this.isAStop = false;
        else
	    this.isAStop = true;
    }
    
}
