package bullybus;
import java.io.*;
import java.util.*;
/**
 * 
 * Class to hold data about the bus stops.
 * 
 *
 * @author Ron Lewis
 * @version 1.00 04/06/03
 */
public class CbnStop implements Serializable{
    /**
     * The stop name or label.
     */
    private String label;
    /**
     * The longitude gps coordinate.
     */
    private float gpsW;
    /**
     * The latitude gps coordinate.
     */
    private float gpsN;
    /**
     * Constructs a new stop.
     * @param label The bus stop name.
     * @param latitude The north south gps coordinate.
     * @param longitude The east west gps coordinate.
     */
    public void CbnStop(String label, float latitude, float longitude)
    {
	this.label = label;
	this.gpsW = longitude;
	this.gpsN = latitude; 
    }
    /**
     * Constructs a blank stop.
     *
     */
    public void CbnStop()
    {
	this.label = null;
	this.gpsW = 0;
	this.gpsN = 0; 
    }
    /**
     * Returns the label
     * @return The bus stop label
     * @see String
     */
    public String getLabel(){ 
	return label; 
    }
    /**
     * Returns the label
     * @return The bus gpsN coordinate
     * 
     */
    public float getGpsN(){ 
	return gpsN; 
    }
    /**
     * Returns the label
     * @return The bus gpsW coordinate
     * 
     */
    public float getGpsW(){ 
	return gpsW; 
    }
    /**
     * Sets the data for this bus.
     * @param label The bus stop name.
     * @param latitude The north south gps coordinate.
     * @param longitude The east west gps coordinate.
     */
    public void setData(String label, float latitude, float longitude){ 
	this.label = label;
	this.gpsW = longitude;
	this.gpsN = latitude; }
     /**
     * Sets the label for this bus.
     * @param label The bus stop name.
     */   
    public void setLabel(String label){ 
	this.label = label; 
    }
     /**
     * Sets the gps data for this bus.
     * 
     * @param latitude The north south gps coordinate.
     * @param longitude The east west gps coordinate.
     */
    public void setGps(float latitude, float longitude){ 
	this.gpsN = latitude; 
	this.gpsW = longitude; 
    }
    /**
     * Sets the gps data for this bus.
     * @param latitude The north south gps coordinate.
     */
    public void setGpsN(float latitude){ 
	this.gpsN = latitude; 
    }
    /**
     * Sets the gps data for this bus.
     * @param longitude The east west gps coordinate.
     */
    public void setGpsW(float longitude){ 
	this.gpsW = longitude;
    }
}
