package bullybus;
import java.awt.*;
import java.awt.Window.*;
import java.awt.event.*;
import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;
import java.applet.*;
import java.sql.*;
import javax.swing.*;
import javax.swing.border.EtchedBorder;
import java.util.Vector;
/**
 *
 * Main Applet for the Bully's Bus Tracker
 * Displays bus positions to the user.
 * 
 *
 * @author Ron Lewis
 * @version 2.0 02/01/2005
 */
public class CbnView extends JApplet implements ActionListener, MouseListener,
MouseMotionListener
{  
   /**
    * The main map for displaying data
    * @see CbnMap
    */ 
   protected CbnMap map;
   /**
    * The frame the gauges for the blue bus are displayed in.
    */ 
   protected Frame _1104Frame = null; 
   /**
    * The frame the gauges for the blue bus are displayed in.
    */
   protected Frame _1003Frame = null;
   /**
    * The frame the gauges for the blue bus are displayed in.
    */
   protected Frame _0903Frame = null;
   /**
    * The frame the gauges for the blue bus are displayed in.
    */
   protected Frame _0898Frame = null;
   /**
    * The frame the gauges for the blue bus are displayed in.
    */
   protected Frame _39tFrame = null;
   /**
    * Button for scrolling the map north.
    */ 
   public ImageButton north;
   /**
    * Button for scrolling the map north west.
    */ 
   public ImageButton nw;
   /**
    * Button for scrolling the map north east.
    */ 
   public ImageButton ne;
   /**
    * Button for scrolling the map south.
    */ 
   public ImageButton south;
   /**
    * Button for scrolling the map south west.
    */ 
   public ImageButton sw;
   /**
    * Button for scrolling the map south east.
    */ 
   public ImageButton se;
   /**
    * Button for scrolling the map East.
    */ 
   public ImageButton east;
   /**
    * Button for scrolling the map West.
    */ 
   public ImageButton west;
   /**
    * The number of zoom buttons or levels 
    */ 
   private static int zoomLevels = 12;
   /**
    * The actual zoom buttons with Roll Over
    */ 
   public RollOverImageButton[] zoom = new RollOverImageButton[zoomLevels];
   /**
    * The zoom in text button
    */ 
   public ImageButton zoomIn;
   /**
    * The zoom in + button
    */ 
   public ImageButton zoomInButton;
   /**
    * The zoom out text button
    */ 
   public ImageButton zoomOut; 
   /**
    * The zoom out - button
    */ 
   public ImageButton zoomOutButton;
   /**
    * The current zoom Level at which the map reside.
    */ 
   private int zoomIndex;
   /**
    * The green route button activates the green route mask
    */ 
   public ImageButton green;
   /**
    * The blue route button activates the blue route mask
    */ 
   public ImageButton blue;
   /**
    * The maroon route button activates the maroon route mask
    */ 
   public ImageButton maroon; 
   /**
    * The gray route button activates the gray route mask
    */ 
   public ImageButton gray; 
   /**
    * The downtown route button activates the downtown route mask
    */ 
   public ImageButton night; 
   /**
    * The downtown route button activates the downtown route mask
    */ 
   public ImageButton downtown;
   /**
    * A spacer used to fill a void.
    */ 
   public ImageButton spacer; 
   /**
    * The local copy of the map's current size
    */ 
   public int mapWidth;
   /**
    * The local copy of the map's current size
    */ 
   public int mapHeight;
   /**
    * The scroll pane that contains the map.  It lets us have those
    * cool pan, scroll, and zoom features.
    */ 
   protected CbnScrollPane s;
   /**
    * Used for mouse events.
    */ 
   protected int mX1;
   /**
    * Used for mouse events.
    */ 
   protected int  mY1;
   /**
    * Used for mouse events.
    */ 
   protected int mX2;
   /**
    * Used for mouse events.
    */ 
   protected int mY2;
   /**
    * The container for the stop data.
    */ 
   protected CbnStopSet sSet;
   /**
    * The container for the current bus data.
    */ 
   protected CbnBuses buses;
   /**
    * The applets preferred width
    */ 
   private static int appWidth = 778;
   /**
    * The applets preferred height
    */ 
   private static int appHeight = 489;
   /**
    * The scrollPanes preferred width
    */ 
   private static int sWidth = 588;
   /**
    * The scrollPanes preferred height
    */ 
   private static int sHeight = 372;
   /**
    * The information box. 
    */ 
   private JTextArea infoBox;
   /**
    * The scroll pane that contains the infoBox
    */ 
   private JScrollPane infoScroll;
   /**
    * The panel that contains the map and all the scroll buttons.
    */ 
   private JPanel mapPanel;
   /**
    * The panel that contains the north buttons.
    */   
   private JPanel northPanel;
   /**
    * The Panel the contains the south buttons.
    */
   private JPanel southPanel;
   /**
    * The panel that contains the zoom buttons.
    */ 
   private JPanel zoomPanel;
   /**
    * The panel that contains the route buttons.
    */ 
   private JPanel routePanel;
   /**
    * The panel that contains the eta information
    */ 
   private JPanel etaPanel;
   /**
    * Image used to make the Rollover zoom buttons
    */ 
   private Image zoomOn;
    /**
     * Blue Route Data Container.
     */
   private CbnRouteDataSet blue_route;
    /**
     * Maroon Route Data Container.
     */
   private CbnRouteDataSet maroon_route;
    /**
     * Gray Route Data Container.
     */
   private CbnRouteDataSet gray_route;
    /**
     * Green Route Data Container.
     */
   private CbnRouteDataSet green_route;
    /**
    * Image used to make the Rollover zoom buttons
    */ 
   private Image zoomOff;
   private ImageButton routeLabel;
   private ImageButton zoomBarTop;
   private ImageButton zoomBarBot;
   private ImageButton routeFill;  
   /**
    * Should I open up the gauges when the mouse is pressed,
    * true when the mouse is over a bus icon.
    */    
   protected boolean gauge_1104 = false;
   /**
    * Should I open up the gauges when the mouse is pressed,
    * true when the mouse is over a bus icon.
    */  
   protected boolean gauge_0903 = false;
   /**
    * Should I open up the gauges when the mouse is pressed,
    * true when the mouse is over a bus icon.
    */  
   protected boolean gauge_1003 = false;
   /**
    * Should I open up the gauges when the mouse is pressed,
    * true when the mouse is over a bus icon.
    */  
   protected boolean gauge_0898 = false;
   /**
    * Should I open up the gauges when the mouse is pressed,
    * true when the mouse is over a bus icon.
    */  
   protected boolean gauge_39t = false;
    /**
     * The list box for Stop Selection.
     */
   protected JComboBox etaStopSelect;
    /**
     * The current stop selected from the etaStopSelect
     */
   protected String selected_stop;
    /**
     * The panel to hold the eta to stop information
     */
   protected CbnEtaPanel etas = new CbnEtaPanel();
   /**
   * The applet init method, puts everything together.
   */  
   public void init (){
      //Begin Layout
      setSize(new Dimension(667,409));
      getContentPane().setLayout(new FlowLayout(1,0,0));
      getContentPane().setBackground(new Color(224,228,201));
      //Create the Main Panels
      mapPanel = new JPanel();
      zoomPanel = new JPanel();
      routePanel = new JPanel();
      etaPanel = new JPanel();
      // Create Sub-Panels
      northPanel = new JPanel();
      southPanel = new JPanel();
      //Create the ScrollPane
      s = new CbnScrollPane();
      //Load the very large image for the map.
      loadMap("/map/transparrent_layer.gif");
      //Set the layout and the size for the mapPanel
      mapPanel.setLayout(new BorderLayout());
      mapPanel.setSize(632,381);
      //Create the navigation buttons
      north = newImageButton("/images/north.jpg", "North");
      nw = newImageButton("/images/nw.jpg", "North");
      ne = newImageButton("/images/ne.jpg", "North");
      south = newImageButton("/images/south.jpg", "South");
      sw = newImageButton("/images/sw.jpg", "North");
      se = newImageButton("/images/se.jpg", "North");
      east = newImageButton("/images/east.jpg", "East");
      west = newImageButton("/images/west.jpg", "West");
      //Add actionlistners to the nav buttons
      north.addActionListener( this);
      nw.addActionListener( this);
      ne.addActionListener( this);
      south.addActionListener( this);
      sw.addActionListener( this);
      se.addActionListener( this);
      east.addActionListener( this);
      west.addActionListener( this);
      //Create the Zoom Button Images.
      zoomOn = loadImage("/images/zoom_on.jpg");
      zoomOff = loadImage("/images/zoom_off.jpg");
      //Create the zoomIn Buttons
      zoomInButton = newImageButton("/images/zoom_in.jpg","ZoomIn");
      //Create the zoom buttons, and add actionListners too.
      for(int m = 0; m < zoomLevels; m++){
	  zoom[m] = new RollOverImageButton(zoomOn, zoomOff, "zoom");
	  zoom[m].addActionListener(this);
	  zoomIndex = m;
      }
      //Free some memory we don't need these anymore. 
      zoomOn = null;
      zoomOff = null;
      //Create the zoomOut buttons
      zoomOutButton = newImageButton("/images/zoom_out.jpg", "ZoomOut");
      zoomBarTop = newImageButton("/images/zoom_bar_fill_top.jpg","");
      zoomBarBot = newImageButton("/images/zoom_bar_fill_bot.jpg","");
      //Add action listeners to the remaining zoom buttons.
      //zoomIn.addActionListener(this);
      zoomInButton.addActionListener(this);
      //zoomOut.addActionListener(this);
      zoomOutButton.addActionListener(this);
      //Create the route buttons
      routeLabel = newImageButton("/images/routes.jpg","Route");
      blue = newImageButton("/images/route_blue.jpg", "Blue");
      gray = newImageButton("/images/route_gray.jpg", "Gray");
      maroon = newImageButton("/images/route_maroon.jpg", "Maroon");
      green = newImageButton("/images/route_green.jpg","Green");
      night = newImageButton("/images/route_night.jpg","Night");
      downtown = newImageButton("/images/route_downtown.jpg","");
      routeFill = newImageButton("/images/route_bar_fill.jpg","");
      //Add the actionListeners to the route buttons.
      blue.addActionListener(this);
      gray.addActionListener(this);
      green.addActionListener(this);
      maroon.addActionListener(this);
      night.addActionListener(this);     
      downtown.addActionListener(this);
      //Set the layout and size for the zoom buttons.
      Insets insets = new Insets(0,0,0,0);
      // Set the constraints for the first button
      GridBagConstraints constraints =
             new GridBagConstraints(
	       0, // Only one column so this number stays 0
	       0, // Increment this number to go to the next row.
               1, 1, // gridwidth, gridheight 
               1.0, 1.0, // weightx, weighty
               GridBagConstraints.NORTHWEST, // anchor to left corner
               GridBagConstraints.HORIZONTAL, // fill all the area horizontally you can
               insets, // insets 
               0, // ipadx
               0); // ipady
      zoomPanel.setSize(35,369);
      zoomPanel.setLayout(new GridBagLayout());
      //Add the first two buttons to the panel
      zoomPanel.add(zoomBarTop, constraints);
      constraints = new GridBagConstraints(0, 1 ,1, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST,
                      GridBagConstraints.HORIZONTAL, insets,0,0);
      zoomPanel.add(zoomInButton, constraints); 
      //Add the twelve zoom buttons to the panel.
      for(int m = 0; m < zoomLevels; m++){
          constraints = new GridBagConstraints(0, m+2 ,1, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST,
                GridBagConstraints.HORIZONTAL, insets,0,0);
	  zoomPanel.add(zoom[m], constraints);
      }
      //Add the last two buttons to the panel.
      constraints = new GridBagConstraints(0, 14 ,1, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST,
                      GridBagConstraints.HORIZONTAL, insets,0,0);
      zoomPanel.add(zoomOutButton, constraints);
      constraints = new GridBagConstraints(0, 15 ,1, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST,
         GridBagConstraints.HORIZONTAL, insets,0,0);
      zoomPanel.add(zoomBarBot, constraints);
      // Used for grid bag layout.
      // I had to use grid bag because the images are different sizes.
      // Set the constraints for the first button
      //Set the layout and size of the route panel
      routePanel.setLayout(new GridBagLayout());
      routePanel.setSize(667,28);
      constraints = new GridBagConstraints(0, 0 ,1, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST,
               GridBagConstraints.HORIZONTAL, insets,0,0);
      routePanel.add(routeLabel, constraints);
      constraints = new GridBagConstraints(1, 0 ,1, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST,
                      GridBagConstraints.HORIZONTAL, insets,0,0);
      routePanel.add(blue,constraints);
      constraints = new GridBagConstraints(2, 0,1, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST,
                      GridBagConstraints.HORIZONTAL, insets,0,0);
      routePanel.add(gray,constraints);
      constraints = new GridBagConstraints(3, 0, 1, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST,
                      GridBagConstraints.HORIZONTAL, insets,0,0);
      routePanel.add(green,constraints);
      constraints = new GridBagConstraints(4, 0, 1, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST,
                      GridBagConstraints.HORIZONTAL, insets,0,0);
      routePanel.add(maroon,constraints);
      constraints = new GridBagConstraints(5, 0, 1, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST,
                      GridBagConstraints.HORIZONTAL, insets,0,0);
      routePanel.add(night,constraints);
      constraints = new GridBagConstraints(6, 0,1, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST,
                      GridBagConstraints.HORIZONTAL, insets,0,0);
      routePanel.add(downtown,constraints);
      constraints = new GridBagConstraints(7, 0, 1, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST,
                      GridBagConstraints.HORIZONTAL, insets,0,0);
      routePanel.add(routeFill,constraints);
      //End routePanel
      //Layout the North Panel
      northPanel.setLayout(new GridBagLayout());
      northPanel.setSize(632,18);
      constraints = new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST,
                      GridBagConstraints.HORIZONTAL, insets,0,0);
      northPanel.add(nw,constraints);
      constraints = new GridBagConstraints(1, 0, 1, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST,
                      GridBagConstraints.HORIZONTAL, insets,0,0);
      northPanel.add(north,constraints);
      constraints = new GridBagConstraints(2, 0, 1, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST,
                      GridBagConstraints.HORIZONTAL, insets,0,0);
      northPanel.add(ne,constraints);
      //End Layout North Panel
      //Layout South Panel
      southPanel.setLayout(new GridBagLayout());
      southPanel.setSize(632,18);
      constraints = new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST,
                      GridBagConstraints.HORIZONTAL, insets,0,0);
      southPanel.add(sw,constraints);
      constraints = new GridBagConstraints(1, 0, 1, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST,
                      GridBagConstraints.HORIZONTAL, insets,0,0);
      southPanel.add(south,constraints);
      constraints = new GridBagConstraints(2, 0, 1, 1, 1.0, 1.0, GridBagConstraints.NORTHWEST,
                      GridBagConstraints.HORIZONTAL, insets,0,0);
      southPanel.add(se,constraints);
      //End SouthPanel Layout
      //Add the nav buttons to the map panel
      mapPanel.add("North", northPanel);
      mapPanel.add("East", east);
      mapPanel.add("West", west);
      mapPanel.add("South", southPanel);
	
      //Add the ScrollPane 
      mapPanel.add("Center", s);
      etaPanel.setSize(667,52);
      etaPanel.setBackground(new Color(224,228,201));
      //Create the etaLisPanel
      JPanel etaListPanel = new JPanel();
      etaListPanel.setLayout(new BorderLayout());
      Vector etaStops = new Vector();
     selected_stop = "-- Select Stop --";
      etaStops.add("-- Select Stop --");
      etaStops.add("AikenVillage");
      etaStops.add("Allen");
      etaStops.add("Bost");
      etaStops.add("Butler");
      etaStops.add("CAVS");
      etaStops.add("Coliseum");
      etaStops.add("Cresswell");
      etaStops.add("ERC");
      etaStops.add("FraternityRow");
      etaStops.add("Giles");
      etaStops.add("Hilbun");
      etaStops.add("Library");
      etaStops.add("MTC");
      etaStops.add("SororityRow1");
      etaStops.add("SororityRow2");
      etaStops.add("Thompson");
      etaStops.add("Union");
      etaStopSelect = new JComboBox(etaStops);  
      etaStopSelect.addActionListener(this); 
      //Add the stop list to the etaStopSelect list box.
      etaStopSelect = new JComboBox(etaStops);  
      etaStopSelect.addActionListener(this); 
      Label etaLabel = new Label("For More Information:", Label.CENTER);
      etaLabel.setForeground(new Color(0,0,0));
      etaLabel.setBackground(new Color(224,228,201));
      etaListPanel.add("North",etaLabel);
      etaListPanel.add("Center", etaStopSelect);
      etaPanel.add(etaListPanel);
      etas = new CbnEtaPanel();
      etaPanel.add(etas);
      //End Layout

      // Retrieve the stop data from the database
      getStops();
      // Retrieve the current bus data from the database
      getBuses();
      //Pass stop data to the map so it can draw them.
      map.setStops(sSet);
      //Pass the bus data to the map so it can draw them.
      map.setBuses(buses);
      //Add an action listener to the map.
      map.addActionListener(this);
      //Retrieve the RouteData From the Database
      blue_route = new CbnRouteDataSet();
      getRouteData("blue");
      gray_route = new CbnRouteDataSet();
      getRouteData("gray");
      green_route = new CbnRouteDataSet();
      getRouteData("green");
      maroon_route = new CbnRouteDataSet();
      getRouteData("maroon");

      //Add all the panel to the content pane.
      getContentPane().add(routePanel);
      getContentPane().add(mapPanel);
      getContentPane().add(zoomPanel);
      getContentPane().add(etaPanel); 
      System.gc();  //Call the garbage collector.
 
   } // End Init
   /**
    * Update the graphics
    */ 
   public void update(Graphics g) {
        Image osImg = createImage(getWidth(), getHeight());
        osImg.getGraphics().fillRect(0,0,getWidth(), getHeight());
        paint(osImg.getGraphics());
        g.drawImage(osImg,0,0,null);
	System.gc();
   }
   /**
    * Method for getting bus data from the database
    * Uses a servlet to make the connection
    */ 
   public void getBuses()
   {
      URL myUrl;
      URLConnection conn;
      InputStream ins = null;
      ObjectInputStream objIns;
      int numOfTimes = 0;
      int i = 0;
      double n,w;
      try{
         long time1 = System.currentTimeMillis();
	 myUrl = new URL("http://bullybus.its.msstate.edu:8080/cbn/servlet/cbnDbGetBuses");
	 conn =myUrl.openConnection();
	 conn.setDoOutput(true);
	 conn.setDoInput(true);
	 conn.setUseCaches(false);
	 conn.setDefaultUseCaches(false);
	 conn.setRequestProperty("Content-Type", "application/octet-stream");
	 try{   
	    ins = conn.getInputStream();
	    objIns = new ObjectInputStream(ins);		
	    buses = (CbnBuses)objIns.readObject();
	    long time2 = System.currentTimeMillis();
	    long elapsedTime= time2 - time1;
	    //System.out.println(" DB Bus reading Time ="+ elapsed Time/1000.0);
	    //System.out.println(" *** Reading values.. done ****");
         }catch(Exception e){          
	     // Try the connection three time then through exception 
	     System.out.println(" EXCEPTION "); 
	     e.printStackTrace();          
	    numOfTimes++;
	    numOfTimes++; 
	    if( numOfTimes > 3) //max attempts  
                  throw e;  
         }
	       
	 myUrl = null;
         conn=null;	    
	    
     }catch(Exception e){
	 e.printStackTrace();
     } 
     
   }// End getBuses()
   /**
    * Method for getting route data from the database 
    * Uses a servlet to make the connection
    */
    public void getRouteData(String route_name)
    {     
      URL myUrl;
      URLConnection conn;
      InputStream ins=null;
      ObjectInputStream objIns;
      int numOfTimes = 0;
      int i = 0;
      double n,w;
      try{
         long time1 = System.currentTimeMillis();
	 myUrl = new URL("http://bullybus.its.msstate.edu:8080/cbn/servlet/cbnDbGetRouteData?route_name="+route_name);
	 conn = myUrl.openConnection();
	 conn.setDoOutput(true);
	 conn.setDoInput(true);
	 conn.setUseCaches(false);
	 conn.setDefaultUseCaches(false);
	 conn.setRequestProperty("Content-Type",
                            "application/octet-stream");

	 //System.out.println(" *** Connecting to Database through Servlet ***");
	 
	 try{   
	     //System.out.println("Trying connection");
	    ins = conn.getInputStream();
	    objIns = new ObjectInputStream(ins);
	    if(route_name == "blue"){		
		blue_route = (CbnRouteDataSet)objIns.readObject();}
	    else if(route_name == "gray"){
		gray_route = (CbnRouteDataSet)objIns.readObject();}
	    else if(route_name == "green"){
		green_route = (CbnRouteDataSet)objIns.readObject();}
	    else if(route_name == "maroon"){
		maroon_route = (CbnRouteDataSet)objIns.readObject();}
	    else{
		// Do Nothing
	    }
	    long time2 = System.currentTimeMillis();
	    long elapsedTime= time2 - time1;
	    System.out.println(" DB Route reading Time ="+ elapsedTime/1000.0);
	    System.out.println(" *** Reading values.. done ****");

         }catch(Exception e){  // Try the connection three time then through exception 
	     System.out.println(" EXCEPTION "); 
	     e.printStackTrace();          
	    numOfTimes++; 
	    if( numOfTimes > 3) //max attempts  
                  throw e;  
         }
	       
	 myUrl = null;
         conn = null;	    
	    
     }catch(Exception e){ // Catch for connection creation.
	 e.printStackTrace();
     } 
     
   } // End getRouteData(String)
   /**
    * Method for getting stops from the database 
    * Uses a servlet to make the connection
    */
   public void getStops()
   {
      URL myUrl;
      URLConnection conn;
      InputStream ins=null;
      ObjectInputStream objIns;
      int numOfTimes = 0;
      int i = 0;
      double n,w;
      try{
         long time1 = System.currentTimeMillis();
	 myUrl = new URL("http://bullybus.its.msstate.edu:8080/cbn/servlet/cbnDbGetStops");
	 conn =myUrl.openConnection();
	 conn.setDoOutput(true);
	 conn.setDoInput(true);
	 conn.setUseCaches(false);
	 conn.setDefaultUseCaches(false);
	 conn.setRequestProperty("Content-Type",
                            "application/octet-stream");

	 //System.out.println(" *** Connecting to Database through Servlet ***");
	 
	 try{   
	     //System.out.println("Trying connection");
	    ObjectOutputStream objOuts= new ObjectOutputStream(conn.getOutputStream());
	    String query = "select * from stops";
	    objOuts.writeObject(query);
	    objOuts.close();
	    ins = conn.getInputStream();
	    objIns = new ObjectInputStream(ins);		

	    sSet = (CbnStopSet)objIns.readObject();
	       
	    long time2 = System.currentTimeMillis();
	    long elapsedTime= time2 - time1;
	    System.out.println(" DB Stop reading Time ="+ elapsedTime/1000.0);
	    System.out.println(" *** Reading values.. done ****");

         }catch(Exception e){   
	     System.out.println(" EXCEPTION "); 
	    e.printStackTrace();          
	    numOfTimes++; 
	    if( numOfTimes > 3) //max attempts  
                  throw e;  
         }
	       
	 myUrl = null;
         conn=null;	    
	    
     }catch(Exception e){
	 e.printStackTrace();
     } 
      System.gc();
   } // End getStops(String)
   /**
    * Method for loading the map image from the jar file.
    */
   public void loadMap (String file) 
   {
      URL url = null;
      try{
         if (map != null) 
	 { 
	    s.removeAll();
       	    s.remove(map);
	    remove(s);
	    s = null; 
	    s = new CbnScrollPane();
	    getContentPane().add(s);
	    map = null; 
	 }
  
	 url = this.getClass().getResource(file);
	 Object o = url.getContent();
	 if (o == null || ! (o instanceof ImageProducer))
	    System.err.println(o +": no ImageProducer");
	 else 
	 {
	    // Create new ImageView  
	    map = new CbnMap((ImageProducer)o);				
	    
	    // Add map to the scrollPane
	    s.add(map);
	    // Add Mouse Listeners to the Canvas
	    map.addMouseListener(this); // For Clicks and such
	    map.addMouseMotionListener(this); // For dragging and such
	  }

     }catch (MalformedURLException me){
        System.err.println(me);
	System.out.println(url.toString());
      }catch (IOException ie){
	  System.err.println(ie);
      }
      System.gc();
   } // End loadImage(String)
   /**
    * Use data from the ImageView Class to set the appropriate
    * width and height for the current image and zoom level.
    */ 
   public void setImageSize(){
      mapHeight = (int)(map.height*map.zoomFactor);
      mapWidth = (int)(map.width*map.zoomFactor);	
    }

    /**
     * This method is for the implementation of the
     * action listeners.
     */
    public void actionPerformed( ActionEvent e) 
    {
       Point p;
       p = s.getScrollPosition(); 
       int x = (int)p.getX();
       int y = (int)p.getY();
       if(e.getActionCommand() == "Blue")// The Blue route button is pressed draw the blue route.
       {
	   map.drawBlueRoute = !map.drawBlueRoute;
	   map.repaint();
       }
       if(e.getActionCommand() == "Gray")// The Gray route button is pressed draw the gray route.
       {
	   map.drawGrayRoute = !map.drawGrayRoute;
	   map.repaint();
       }
       if(e.getActionCommand() == "Green")// The Green route button is pressed draw the green route.
       {
	   map.drawGreenRoute = !map.drawGreenRoute;
	   map.repaint();
       }
       if(e.getActionCommand() == "Maroon") // The Maroon route button is pressed dras the maroon route.
       {
	   map.drawMaroonRoute = !map.drawMaroonRoute;
	   map.repaint();
       }
       if(e.getActionCommand() == "Night") // The Maroon route button is pressed dras the maroon route.
       {
	   map.drawNightRoute = !map.drawNightRoute;
	   map.repaint();
       }
       if(e.getActionCommand() == "Center") //Command to center the map on startup
       {   
	   map.zoomFactor = .45;
	   setImageSize();
	   zoom[11].isOn = true;
	   zoom[11].repaint();
           s.setScrollPosition(this.mapWidth/2,this.mapHeight/2);
       }
       if(e.getActionCommand() == "North") // The North button is pressed
       {  
          y -= sHeight/2; // decrement by 1/2 the size of the canvas
	  if(y < 0) //Can't move further north than 0
	  {
	     y = 0;
	  }	
	  s.setScrollPosition(x, y);
	  map.repaint();
       }
       if(e.getActionCommand() == "South") // The South button is pressed
       {
	  if (mapHeight == -1){  // Make sure the local image Variables are set 
	      setImageSize();	  // This method depends on these variables
	  }
	  y += sHeight/2;
	  if(y > (mapHeight - sHeight))
	  {
	     y = mapHeight - sHeight;
	  }		
	  s.setScrollPosition(x, y);
       }
       if(e.getActionCommand() == "East")// The East button is pressed
       {
          if (mapWidth == -1){
	    setImageSize();
	  }
	  x += sWidth/2;  // Increment by 1/2 the size of the scrollPane
	  if(x > (mapWidth - sWidth) )
	  {
	     x = mapWidth - sWidth;		
	  }
	  s.setScrollPosition(x, y);	

       }
       if(e.getActionCommand() == "West")// The West button is pressed
       {
          x -= sWidth/2;// decrement by 1/2 the size of the scrollPane
	  if(x < 0)// Can't go West no more end of map
	  {
	     x = 0;
	  }	
	  s.setScrollPosition(x, y);
	}
       if(e.getActionCommand() == "GetBuses") // The GetBuses action Note: This is fire from the CbnMap class
       {
	   getBuses();// Retrieve new bus data.
	   try{
	   if(!selected_stop.equals("-- Select Stop --")) // Calculate and set the etas, if a stop is selected.
	   {
	       //etas.eta1.setText(blue_route.etaToStop(selected_stop, buses.getBus(0).getGpsN(), buses.getBus(0).getGpsW()));
    	       etas.eta2.setText(gray_route.etaToStop(selected_stop, buses.getBus(1).getGpsN(), buses.getBus(1).getGpsW()));
  	       etas.eta3.setText(green_route.etaToStop(selected_stop, buses.getBus(2).getGpsN(), buses.getBus(2).getGpsW()));
	       etas.eta4.setText(maroon_route.etaToStop(selected_stop, buses.getBus(4).getGpsN(), buses.getBus(4).getGpsW()));

	   }
	   else{
	       etas.eta1.setText("N/A");
    	       etas.eta2.setText("N/A");
  	       etas.eta3.setText("N/A");
	       etas.eta4.setText("N/A");
	   }
	   }catch(Exception ex){}
	   map.setBuses(buses); // Send the buses to the map.
	   map.repaint(); // Repaint the map.
       }
       if(e.getActionCommand() == "ZoomIn")//ZoomIn action
       {
	   if(zoomIndex > 0)
	   {
	       processZoom(p, zoomIndex-1); 
	   }
	}
       if(e.getActionCommand() == "ZoomOut")//ZoomOut Action
       {
	
	   if(zoomIndex < 11)
	   {
	      processZoom(p, zoomIndex+1);  
           }
       }
       if(e.getActionCommand() == "zoom")//ZoomAction
       {
	     int level = 0;
	     for(int i = 0; i < zoomLevels; i++)
	     {
		 if(e.getSource() == zoom[i])
		 {
		     level = i;
		     break;
		 }
	     }
	     processZoom(p, level);
	 } 
       if(e.getSource() == etaStopSelect)//The list box value has changed.
       {
            selected_stop = (String)etaStopSelect.getSelectedItem();
       }
    }
    /**
     * Processes zoom events.  This fuction is used to zoom the map in and out.
     * It also updates the zoom buttons to mark the current zoom level.
     */
    public void processZoom(Point p, int buttonIndex)
    {
       int x = (int)p.getX()+sWidth/2;  // Get the center point of the screen
       int y = (int)p.getY()+sHeight/2;
       int w = mapWidth, h = mapHeight;
       float newZoomLevel = (float)( 1 - (buttonIndex*.05));
       float n_x, n_y;
       if(map.zoomFactor != newZoomLevel)  // Make sure not on this level
       {
          map.zoomFactor = newZoomLevel;  // Decrease the zoom level			
          setImageSize();
			
          n_x = (float)x/(float)(w)*(float)(mapWidth);  // Calculate new center point
          n_y = (float)y/(float)(h)*(float)(mapHeight);

          x = (int)n_x-sWidth/2; // Find the scroll position 
          y = (int)n_y-sHeight/2;
		    
          if(x > mapWidth - sWidth)  // Make sure we are not out of bounds of the image
          {
             x = mapWidth - sWidth;
          }
	  if(y > mapHeight - sHeight)
	  {
	     y = mapHeight - sHeight;
	  }
	  s.setScrollPosition(x,y); // Set the Scroll position
	  map.repaint();  // Make the applet repaint
	       
          zoom[zoomIndex].isOn = false;
	  zoom[zoomIndex].repaint();
	  zoomIndex = buttonIndex;
	  zoom[zoomIndex].isOn = true;
	  zoom[zoomIndex].repaint();    
       }
    } 
    /**
     * This function loads an image from the jar file.
     */
    public Image loadImage(String file)
    {
      URL url = null;
      Image temp = null;
      try{
    
	 url = this.getClass().getResource(file);
	 Object o = url.getContent();
	 if (o == null || ! (o instanceof ImageProducer)){
	    System.err.println(o +": no ImageProducer");
	 }
	 else 
	 {
	    // Create new Image  
	    temp = createImage((ImageProducer)o);				
	  }

     }catch (MalformedURLException me){
        System.err.println(me);
	System.out.println(url.toString());
      }catch (IOException ie){
	  System.err.println(ie);
      }
      return temp; //Return the new Image.
   } // End newImageButton(String)
   /**
    * This function load the specified image from the jar file, and
    * creates a new ImageButton.
    */
    public ImageButton newImageButton(String file, String label)
    {
      URL url = null;
      ImageButton temp = null;
      try{
         url = this.getClass().getResource(file);
	 Object o = url.getContent();
	 if (o == null || ! (o instanceof ImageProducer)){
	    System.err.println(o +": no ImageProducer");
	 }
	 else 
	 {
	    // Create new ImageButton  
	    temp = new ImageButton((ImageProducer)o, label);				
	  }

     }catch (MalformedURLException me){
        System.err.println(me);
	System.out.println(url.toString());
      }catch (IOException ie){
	  System.err.println(ie);
      }
      return temp; // Return the new ImageButton.
   } // End newImageButton(String) 
   /**
    * Methods for mouseListener and mouseMotionListener
    */
   public void mousePressed(MouseEvent e) {  // Case for mousePressed 
     if(e.getSource() == map)
     {
        mX1 = e.getX();
	mY1 = e.getY();
     
	if(e.getButton() ==  MouseEvent.BUTTON2){ }
	// Change the cursor to the move cursor
	else if(e.getButton() == MouseEvent.BUTTON1 && !gauge_39t && !gauge_1104 && 
                                          !gauge_1003 && !gauge_0903 && !gauge_0898){  
           Cursor cursor = new Cursor(Cursor.MOVE_CURSOR);
	   setCursor(cursor);
	}
	else{}// Do nothing.
     }
   }
   /**
    * Case for mouse released
    */
   public void mouseReleased(MouseEvent e) { // Change the cursor back
       if(e.getSource() == map){
          Cursor cursor = new Cursor(Cursor.DEFAULT_CURSOR);
          setCursor(cursor);
          if(e.getButton() == MouseEvent.BUTTON1 && gauge_39t && _39tFrame == null){
             newGauges("39t");
          }
	  else if(e.getButton() == MouseEvent.BUTTON1 && gauge_1104 && _1104Frame == null){
             newGauges("1104");
          }
	  else if(e.getButton() == MouseEvent.BUTTON1 && gauge_1003 && _1003Frame == null){
             newGauges("1003");
          }
	  else if(e.getButton() == MouseEvent.BUTTON1 && gauge_0903 && _0903Frame == null){
             newGauges("0903");
          }
	  else if(e.getButton() == MouseEvent.BUTTON1 && gauge_0898 && _0898Frame == null){
             newGauges("0898");
          }
	  else{}
       }
   }
   /** 
    * Case for mouseExited. Not Used
    */
   public void mouseExited(MouseEvent e){
   }
   /**
    * Case for mouseEntered. Not Used
    */
   public void mouseEntered(MouseEvent e){
   }
   /** 
    * Case for mouseClicked. 
    */ 
   public void mouseClicked(MouseEvent e){     // When the middle mouse button is pressed

      if( e.getSource() == map ){
         if (e.getButton() == MouseEvent.BUTTON2) // center the map at the position.
         {
	    int x = e.getX();  // Get point where mouse clicked
	    int y = e.getY();
	    x -= sWidth/2; // Find the scroll Position
	    y -= sHeight/2;
	    if(x > mapWidth - sWidth)  //Make sure we do not get out 
	    {                       //of bounds
	       x = mapWidth - sWidth;
	    }
	    if(y > mapHeight - sHeight)
	    {
	       y = mapHeight - sHeight;
	    }
	    s.setScrollPosition(x,y);  // Finally set the scroll position
         }
      }
   }
   /**
    * Case for mouse Dragged.
    */ 
   public void mouseDragged(MouseEvent e) // Drag the image to a new position
   {
       if(e.getSource() == map)
       { 
          Point p = s.getScrollPosition();  // Get the scroll position
	  int x = (int)p.getX();   
	  int y = (int)p.getY();

	  mX2 = e.getX(); // Get the mouse position
	  mY2 = e.getY();

	  int diffx = mX1 - mX2; //Calculate the difference
	  int diffy = mY1 - mY2;

	  x += diffx;  // Add the Difference to the scroll
	  y += diffy;  // position

	  if(x > mapWidth - sWidth)  // Make sure we are not out of bounds
	  {
	     x = mapWidth - sWidth;
	  }
	  if(y > mapHeight - sHeight)
	  {
             y = mapHeight - sHeight;
	  }
          if(!gauge_39t && !gauge_1104 && !gauge_0903 && !gauge_1003 && !gauge_0898 ){
	     s.setScrollPosition(x,y);  // Set the new Scroll Position
	  }
       }
    }
    /** 
     * Case for Mouse Moved.
     */
    public void mouseMoved(MouseEvent e)
    {
       int Y = (int)(calculateY(buses.getBus(0).getGpsN()));
       int X = (int)(calculateX(buses.getBus(0).getGpsW()));
       int Y1 = (int)(calculateY(buses.getBus(1).getGpsN()));
       int X1 = (int)(calculateX(buses.getBus(1).getGpsW()));
       int Y2 = (int)(calculateY(buses.getBus(2).getGpsN()));
       int X2 = (int)(calculateX(buses.getBus(2).getGpsW()));
       int Y3 = (int)(calculateY(buses.getBus(3).getGpsN()));
       int X3 = (int)(calculateX(buses.getBus(3).getGpsW()));
       int Y4 = (int)(calculateY(buses.getBus(4).getGpsN()));
       int X4 = (int)(calculateX(buses.getBus(4).getGpsW()));     
       
       mX2 = e.getX(); // Get the mouse position
       mY2 = e.getY();  
       int iS = (int)(34/2); // The size of the bus icons
       if(( mX2 > X - iS && mX2 < X + iS) && ( mY2 > Y - iS && mY2 < Y + iS))
       {
	   gauge_39t = true;
	   Cursor cursor = new Cursor(Cursor.HAND_CURSOR );
	   setCursor(cursor);
       } 
       else if(( mX2 > X1 - iS && mX2 < X1 + iS) && ( mY2 > Y1 - iS && mY2 < Y1 + iS))
       {
	   gauge_1104 = true;
	   Cursor cursor = new Cursor(Cursor.HAND_CURSOR );
	   setCursor(cursor);
       } 
       else if(( mX2 > X2 - iS && mX2 < X2 + iS) && ( mY2 > Y2 - iS && mY2 < Y2 + iS))
       {
	   gauge_1003 = true;
	   Cursor cursor = new Cursor(Cursor.HAND_CURSOR );
	   setCursor(cursor);
       }
       else if(( mX2 > X3 - iS && mX2 < X3 + iS) && ( mY2 > Y3 - iS && mY2 < Y3 + iS))
       {
	   gauge_0903 = true;
	   Cursor cursor = new Cursor(Cursor.HAND_CURSOR );
	   setCursor(cursor);
       }
       else if(( mX2 > X4 - iS && mX2 < X4 + iS) && ( mY2 > Y4 - iS && mY2 < Y4 + iS))
       {
	   gauge_0898 = true;
	   Cursor cursor = new Cursor(Cursor.HAND_CURSOR );
	   setCursor(cursor);
       }
       else{
	   Cursor cursor = new Cursor(Cursor.DEFAULT_CURSOR);
	   setCursor(cursor);
	   gauge_39t = false;
	   gauge_1104 = false;
	   gauge_1003 = false;
	   gauge_0903 = false;
	   gauge_0898 = false;
       }
    }
    /**
     * Calculates the x position to draw object on the map
     * based on the objects gps coordinates.
     */
    public int calculateY(float y)
    {
	return map.calculateY(y);
    }
    /**
     * Calculates the y position to draw object on the map
     * based on the objects gps coordinates.
     */
    public int calculateX(float x)
    { 
	return map.calculateX(x);
    }
    /**
     * Creates a new gauge class and opens it in a frame.
     */
    void newGauges(String busName){
	if(busName == "1104"){
	    if(_1104Frame == null){
		_1104Frame = new Frame();
		_1104Frame.setFont(new Font("Courier", Font.BOLD, 16));
		_1104Frame.addWindowListener(new java.awt.event.WindowAdapter() 
		{
		    public void windowClosing(java.awt.event.WindowEvent e) 
		    {
			//System.exit(0);
			_1104Frame.setVisible(false);
			_1104Frame.dispose();
			_1104Frame = null;
		    };
		});
		_1104Frame.setTitle(busName+" Gauges");
		_1104Frame.setResizable(false);
		Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
		_1104Frame.setLocation((screen.width - 824)/2, (screen.height - 304)/2);
	
		CbnGauges cg = new CbnGauges(busName);
		cg.setSize(824,320); // same size as defined in the HTML APPLET
		_1104Frame.add(cg);
		_1104Frame.setSize(824,320 + 20); // add 20, seems to be enough for the Frame title,
		_1104Frame.setVisible(true);

	    }
	}
	if(busName == "1003"){
	    if(_1003Frame == null){
		_1003Frame = new Frame();
		_1003Frame.setFont(new Font("Courier", Font.BOLD, 16));
		_1003Frame.addWindowListener(new java.awt.event.WindowAdapter() 
		{
		    public void windowClosing(java.awt.event.WindowEvent e) 
		    {
			//System.exit(0);
			_1003Frame.setVisible(false);
			_1003Frame.dispose();
			_1003Frame = null;
		    };
		});
		_1003Frame.setTitle(busName+" Gauges");
		_1003Frame.setResizable(false);
		Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
		_1003Frame.setLocation((screen.width - 824)/2, (screen.height - 304)/2);
	
		CbnGauges cg = new CbnGauges(busName);
		cg.setSize(824,320); // same size as defined in the HTML APPLET
		_1003Frame.add(cg);
		_1003Frame.setSize(824,320 + 20); // add 20, seems to be enough for the Frame title,
		_1003Frame.setVisible(true);

	    }
	}
	if(busName == "0903"){
	    if(_0903Frame == null){
		_0903Frame = new Frame();
		_0903Frame.setFont(new Font("Courier", Font.BOLD, 16));
		_0903Frame.addWindowListener(new java.awt.event.WindowAdapter() 
		{
		    public void windowClosing(java.awt.event.WindowEvent e) 
		    {
			//System.exit(0);
			_0903Frame.setVisible(false);
			_0903Frame.dispose();
			_0903Frame = null;
		    };
		});
		_0903Frame.setTitle(busName+" Gauges");
		_0903Frame.setResizable(false);
		Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
		_0903Frame.setLocation((screen.width - 824)/2, (screen.height - 304)/2);
	
		CbnGauges cg = new CbnGauges(busName);
		cg.setSize(824,320); // same size as defined in the HTML APPLET
		_0903Frame.add(cg);
		_0903Frame.setSize(824,320 + 20); // add 20, seems to be enough for the Frame title,
		_0903Frame.setVisible(true);

	    }
	}
	if(busName == "0898"){
	    if(_0898Frame == null){
		_0898Frame = new Frame();
		_0898Frame.setFont(new Font("Courier", Font.BOLD, 16));
		_0898Frame.addWindowListener(new java.awt.event.WindowAdapter() 
		{
		    public void windowClosing(java.awt.event.WindowEvent e) 
		    {
			//System.exit(0);
			_0898Frame.setVisible(false);
			_0898Frame.dispose();
			_0898Frame = null;
		    };
		});
		_0898Frame.setTitle(busName+" Gauges");
		_0898Frame.setResizable(false);
		Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
		_0898Frame.setLocation((screen.width - 824)/2, (screen.height - 304)/2);
	
		CbnGauges cg = new CbnGauges(busName);
		cg.setSize(824,320); // same size as defined in the HTML APPLET
		_0898Frame.add(cg);
		_0898Frame.setSize(824,320 + 20); // add 20, seems to be enough for the Frame title,
		_0898Frame.setVisible(true);

	    }
	}
	if(busName == "39t"){
	    if(_39tFrame == null){
		_39tFrame = new Frame();
		_39tFrame.setFont(new Font("Courier", Font.BOLD, 16));
		_39tFrame.addWindowListener(new java.awt.event.WindowAdapter() 
		{
		    public void windowClosing(java.awt.event.WindowEvent e) 
		    {
			//System.exit(0);
			_39tFrame.setVisible(false);
			_39tFrame.dispose();
			_39tFrame = null;
		    };
		});
		_39tFrame.setTitle(busName+" Gauges");
		_39tFrame.setResizable(false);
		Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
		_39tFrame.setLocation((screen.width - 824)/2, (screen.height - 304)/2);
	
		CbnGauges cg = new CbnGauges(busName);
		cg.setSize(824,320); // same size as defined in the HTML APPLET
		_39tFrame.add(cg);
		_39tFrame.setSize(824,320 + 20); // add 20, seems to be enough for the Frame title,
		_39tFrame.setVisible(true);

	    }
	}


    }   
    
}
