/*
 * @(#)GpsCalculator.java        2.0 01/25/2005
 *
 * Copyright (c) 2004 CAVS, All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and
 * without fee is hereby granted.
 *
 */
package bullybus;

/**
 * This class holds functions relative gps
 * coordinates. 
 * 
 * @author Ron Lewis
 * @version 2.0 01/25/2005
 */

public class GpsCalculator
{
  private static double r = 3956.0; //Radius of the Earth in Miles
  /**
   * The sole constructor.
   */
  public GpsCalculator(){ }
    /**
     * This fuctions takes two gps coordinates in Decimal Degrees
     * and output the distance between the two in miles.
     * 
     *
     */
  public static double calculateDistance( double lat1, double lon1, double lat2, double lon2)
  {
    double rlon2 = lon2*(Math.PI/180);  // Convert Decimal Degrees to 
    double rlat2 = lat2*(Math.PI/180);  // Radians
    double rlon1 = lon1*(Math.PI/180);  //
    double rlat1 = lat1*(Math.PI/180);  //

    double dlon = rlon2 - rlon1;  // Differential Longitude
    double dlat = rlat2 - rlat1;  // Differential Latitude

    // The following Formula is the Haversine Formula.  
    // 
    double a = Math.pow((Math.sin(dlat/2)),2) + 
               Math.cos(rlat1)*Math.cos(rlat2)*Math.pow(Math.sin(dlon/2),2);
    double c = 2*Math.atan2(Math.sqrt(a), Math.sqrt(1-a));
    double d = r*c;
    return d;
  }
}
